#!/bin/sh -e
# $Id: srcUP.m4,v 1.11 2006/12/19 07:52:04 babolo Exp $
           ln=/bin/ln
           ls=/bin/ls
           ps=/bin/ps
           rm=/bin/rm
           sh=/bin/sh
          cat=/bin/cat
         date=/bin/date
         kill=/bin/kill
        mkdir=/bin/mkdir
        sleep=/bin/sleep
     realpath=/bin/realpath
       sysctl=/sbin/sysctl
           id=/usr/bin/id
           tr=/usr/bin/tr
           wc=/usr/bin/wc
          awk=/usr/bin/awk
          cvs=/usr/bin/cvs
          sed=/usr/bin/sed
         find=/usr/bin/find
         grep=/usr/bin/grep
         head=/usr/bin/head
         make=/usr/bin/make
         sort=/usr/bin/sort
         tail=/usr/bin/tail
        fetch=/usr/bin/fetch
        lockf=/usr/bin/lockf
        patch=/usr/bin/patch
        uname=/usr/bin/uname
       printf=/usr/bin/printf
      dirname=/usr/bin/dirname
     basename=/usr/bin/basename
     readlink=/usr/bin/readlink
 mkinittmpdir=/usr/bin/mkinittmpdir
           pw=/usr/sbin/pw
        chown=/usr/sbin/chown
          su2=/usr/local/bin/su2
        cvsup=/usr/local/bin/cvsup
      wait_on=/usr/local/bin/wait_on

    groupfile=/etc/group
     passfile=/etc/passwd
        suser=CVShome
        su_id=65536
      tmplock=/tmp/srcUP.lock
       cvsdir=/home/${suser}/`${uname}`
       cvshis=${cvsdir}/.srcUP.history
      cvslock=${cvsdir}/.srcUP.lock
       srcdir=/usr/src
       srchis=${srcdir}/.srcUP.history
      srclock=${srcdir}/.srcUP.lock
     portsdir=/usr/ports
     portshis=${portsdir}/.srcUP.history
    portslock=${portsdir}/.srcUP.lock
     localdir=/home/LOCAL
     localhis=${localdir}/.srcUP.history
    locallock=${localdir}/.srcUP.lock
       cvserv=anoncvs@cvs.pike.ru:/repo
 FreeBSDCVSup=cvsup2.ru.FreeBSD.org
       supdir=/var/net/sup
       myname=`${realpath} "${0}"`

4<<- EOF
	srcUP @BABOLO V.M `${cat} BUILDINCLUDEDIR/srcUP.VERSION` + VERS
	Usage:
	  srcUP checkall -   
	  srcUP cvs [host [subdir [repo]...]] -  ${cvsdir}
	  srcUP fetch -      
	  srcUP fetchall -   
	  srcUP local -  ${localdir}
	  srcUP lock [] -  ${cvsdir}  ${srcdir}
	  srcUP new - 
	  srcUP patchports -     
	  srcUP patchsrc -     
	  srcUP ports -  ${portsdir}
	  srcUP src -  ${srcdir}
	  srcUP stat -   
	  srcUP unlock -  ${cvsdir}  ${srcdir}
EOF

if  [ -z "${cmd:=${1}}" ]; then
    ${cat} /dev/fd/4
    exit
fi
shift

patchsrclist="\
    src.contrib.libpcap.pcap-bpf\
    src.etc.mtree.var\
    src.etc\
    src.gnu.usr.bin.man.man\
    src.sbin.route\
    src.share.skel\
    src.share.syscons.fonts.koi8-r-thin-8x8\
    src.sys.dev.drm.radeon\
    src.sys.kern.subr\
    src.sys.miscfs.nullfs\
    src.sys.modules.Makefile\
    src.sys.netinet\
    src.sys.softdep\
    src.usr.bin.mkinittmpdir\
    src.usr.sbin.arp\
"

patchportslist="\
    ports.Mk.port.mk\
    ports.TMPDIR\
    ports.graphics.hobbes-icons-xpm\
    ports.irc.tr-ircd\
    ports.mail.nullmailer\
    ports.net.argus\
    ports.news.inn\
"

trap 'r="$?"; if [ "${r}" -eq "75" ]; then echo -n ": "; ${ls} -l ${tmplock}; fi; exit ${r}' EXIT

if  [ -e `${dirname} BINDIR`/etc/srcUP.conf ]; then
    . `${dirname} BINDIR`/etc/srcUP.conf
fi

u=`${id} -un`

case ${cmd} in
src)            ########################################################################################
    srcx() {
        EXELOCK(cvs,src,dnl
            cd ${srcdir}
            ${cvs} -qR up -dP
            STAMP(${srchis})
)  }
    WAITON(srcx)
    ;;
ports)          ########################################################################################
    portsx() {
        EXELOCK(cvs,ports,dnl
            cd ${portsdir}
            ${cvs} -qR up -dAP
            STAMP(${portshis})
)  }
    WAITON(portsx)
    ;;
local)          ########################################################################################
    localx() {
        EXELOCK(local,dnl
            cd ${localdir}
            if  [ -f MAKE ]; then
                if  [ -d ${localdir}/local/kernconfig ]; then
                    for i in \"\\\\\\\`${sh} -e MAKE fbsdkern\\\\\\\`\"; do
                        cd ${localdir}/local/kernconfig
                        RMLINK(f,\\\\\\\${i})
                    done
                fi
                cd ${localdir}
                for i in \"\\\\\\\`${sh} -e MAKE fbsdport\\\\\\\`\"; do
                    RMLINK(d,\\\\\\\${i})
                done
            fi
            for i in \\\\\\\`${find} . -type l\\\\\\\`; do
                if  [ ! -e \"\\\\\\\${i}\" ]; then ${rm} -f \"\\\\\\\${i}\"; fi
            done
            ${cvs} -qR up -dAP
            if  [ -f MAKE ]; then ${sh} -e MAKE in 1>&2; fi
            STAMP(${localhis})
)  }
    WAITON(localx)
    ;;
patchsrc)       ########################################################################################
    patchsrcx() {
        EXELOCK(src,dnl
            GETOTMP(babolo/patchFBSD)
            ${mkdir} -p ${srcdir}/usr.bin/mkinittmpdir
            for i in ${patchsrclist}; do
                ERROR(,\\\\\\\${i})
                if ! ${patch} -Esd ${srcdir} -i \${TMPDIR}/babolo/patchFBSD/\\\\\\\${i}.patch; then
                    ERROR(,\": \\\\\\\${i}.patch\")
                fi
            done
            ${find} ${srcdir} -name '*.orig' -print -delete
)  }
    WAITON(patchsrcx)
    ;;
patchports)     ########################################################################################
    patchportsx() {
        EXELOCK(ports,dnl
            GETOTMP(babolo/patchFBSD)
            for i in ${patchportslist}; do
                ERROR(,\\\\\\\${i})
                if ! ${patch} -Esd ${portsdir} -i \${TMPDIR}/babolo/patchFBSD/\\\\\\\${i}.patch; then
                    ERROR(,\": \\\\\\\${i}.patch\")
                fi
            done
            ${find} ${portsdir} -name '*.orig' -print -delete
)  }
    WAITON(patchportsx)
    ;;
stat|look)      ########################################################################################
    EXEUSER(dnl
        LOOKLOCK(cvs, )
        LOOKLOCK(src,              )
        LOOKLOCK(ports,            )
        LOOKLOCK(local,           )
        ERROR(,)
        LOOKHIST(cvs, )
        LOOKHIST(src,              )
        LOOKHIST(ports,            )
        LOOKHIST(local,           )
)dnl
    ;;
fetch)          ########################################################################################
    list="$@"
    fetchx() {
        EXELOCK(${make} fetch-recursive ${list})
    }
    t=0
    for i in `${make} -V SUBDIR "${@}"`; do
        t=$(( ${t} + 1 ))
        (cd ${i}; "${myname}" fetch "${@}")
    done
    if  [ ${t} -eq 0 ]; then
        WAITON(fetchx)
    fi
    ;;
lock)           ########################################################################################
    if  [ -n "${knd:=${1}}" ]; then shift; fi
    EXEPRIV(${suser},dnl
        case "${knd}" in
        cvs)
            LOCK(cvs, $*)
            ;;
        src)
            LOCK(src, $*)
            ;;
        ports)
            LOCK(ports, $*)
            ;;
        local)
            LOCK(local, $*)
            ;;
        *)
            LOCK(cvs, "${knd} $*")
            LOCK(src, "${knd} $*")
            ;;
        esac
)dnl
    ;;
unlock)         ########################################################################################
    EXEPRIV(${suser},dnl
        case "${1}" in
        cvs)
            LOCK(cvs); ${rm} -f ${cvslock}
            ;;
        src)
            LOCK(src); ${rm} -f ${srclock}
            ;;
        ports)
            LOCK(ports); ${rm} -f ${portslock}
            ;;
        local)
            LOCK(local); ${rm} -f ${locallock}
            ;;
        '')
            LOCK(cvs)
            LOCK(src)
            ${rm} -f ${srclock}
            ${rm} -f ${cvslock}
            ;;
        *)
            ERROR(1,":   ${1}")
            ;;
        esac
)dnl
    ;;
cvs)            ########################################################################################
    n3="${3:-cvs-all}"
    if  [ -n "${1}" ]; then
        FreeBSDCVSup="${1}"
        if  [ -n "${2}" ]; then
            cvsdir="`${dirname} ${cvsdir}`/${2}"
            cvslock="${cvsdir}/`${basename} ${cvslock}`"
            cvshis="${cvsdir}/`${basename} ${cvshis}`"
            n4="${4}"
            n5="${5}"
            n6="${6}"
            n7="${7}"
            n8="${8}"
            n9="${9}"
            n10="${10}"
            n11="${11}"
            n12="${12}"
    fi; fi

    cvsx() {
        EXELOCT(cvs,dnl

            5<<- EOP
		*default host=${FreeBSDCVSup}
		*default base=`${dirname} ${supdir}`
		*default prefix=${cvsdir}
		*default release=cvs
		*default delete use-rel-suffix
		#*default compress

		${n3}
		${n4}
		${n5}
		${n6}
		${n7}
		${n8}
		${n9}
		${n10}
		${n11}
		${n12}
EOP
            ${cvsup} -gL2 /dev/fd/5
            STAMP(${cvshis})
)  }
    WAITON(cvsx)
    ;;
new)            ########################################################################################
    EXEPRIV(root,dnl
        if ! ${grep} -q "^${suser}:" ${groupfile}; then
            EXERR(1, ${pw} groupadd ${suser} -qg ${su_id})
        fi
        if ! ${grep} -q "^${suser}:" ${passfile}; then
            EXERR(1, ${pw} useradd ${suser} -qu ${su_id} -g ${su_id} -c 'CVS owner' -w no)
        fi
        ${mkdir} -p ${cvsdir} ${srcdir} ${portsdir} ${localdir} ${supdir}
        ${mkdir} -p `${dirname} ${cvsdir}`/.desk `${dirname} ${cvsdir}`/.ssh
        if  [ -d "${srcdir}/CVS" ]; then
            TSTFILL(src, CVS/Root, ${cvsdir})
            TSTFILL(src, CVS/Repository, src)
            TSTFILL(src, CVS/Tag, TRELENG_4)
        else
            ${mkdir} "${srcdir}/CVS"
            UFILL(src, CVS/Root, ${cvsdir})
            UFILL(src, CVS/Repository, src)
            UFILL(src, CVS/Tag, TRELENG_4)
            UFILL(src, CVS/Entries, )
        fi
        if  [ -d "${portsdir}/CVS" ]; then
            TSTFILL(ports, CVS/Root, ${cvsdir})
            TSTFILL(ports, CVS/Repository, ports)
        else
            ${mkdir} "${portsdir}/CVS"
            UFILL(ports, CVS/Root, ${cvsdir})
            UFILL(ports, CVS/Repository, ports)
            UFILL(ports, CVS/Entries, )
        fi
        if  [ -d "${localdir}/CVS" ]; then
            TSTFILL(local, CVS/Root, ${cvserv}/ports)
            TSTFILL(local, CVS/Repository, .)
        else
            ${mkdir} "${localdir}/CVS"
            UFILL(local, CVS/Root, ${cvserv}/ports)
            UFILL(local, CVS/Repository, .)
            UFILL(local, CVS/Entries, )
        fi
        ${chown} -R "${suser}:${suser}" ${cvsdir} ${srcdir} ${portsdir} ${localdir} ${supdir}
        ${chown} -R "${suser}:${suser}" `${dirname} ${cvsdir}`/.desk `${dirname} ${cvsdir}`/.ssh
        if  [ ! -e "/sys" -a ! -L "/sys" ]; then
            ln -s "`echo "${srcdir}/sys" | sed -e 's|^/||'`" /sys
        elif  [ ! -L /sys ]; then
            ERROR(1,": /sys  ")
        elif [ "\`${readlink} /sys\`" != "`echo "${srcdir}/sys" | sed -e 's|^/||'`" ]; then
            ERROR(1,": /sys    `echo "${srcdir}/sys" | sed -e 's|^/||'`")
        fi
)dnl
    newx() {
        EXELOCK(local,dnl
            cd ${localdir}
            for i in usr ports ; do
                if  [ -L \\\\\\\${i} ]; then
                    if  [ \"\\\\\\\`${readlink} \\\\\\\${i}\\\\\\\`\" != '.' ]; then
                        ERROR(1,\": \\\\\\\${i}    '.'\")
                    fi
                elif [ -e \\\\\\\${i} ]; then
                    ERROR(1,\": \\\\\\\${i} ,   \")
                else
                    ${ln} -s . \\\\\\\${i}
                fi
            done
)  }
    WAITON(newx)
    ;;
checkall)       ########################################################################################
    cd ${portsdir}
    if  [ -z "${1}" ] ; then
        list=` ${ls}\
             | ${grep} -vE '^(CVS|distfiles|pkg|Mk|Templates|Tools)$'\
             | ${tr} '\n' ' '
             `
    else
        list="$@"
    fi
    checkallx() {
        EXELOCK(ports,dnl
            for j in ${list}; do
                if  [  -d \"${portsdir}/\\\\\\\${j}\" ] ; then
                    cd \"${portsdir}/\\\\\\\${j}\"
                    for i in \\\\\\\`${ls} | ${grep} -vE '^(CVS|pkg)$'\\\\\\\` ; do
                        if  [ -d \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\" ] ; then
                            cd \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\"
                            ERROR(,\"                   ----------------------====================== \\\\\\\${j}/\\\\\\\${i}\")
                            ( echo ; echo ; TBN ; TBN ; TBN ; TBN ) | ${make} checksum 1>&2 || :
                        fi
                    done
                fi
            done
)
    }
    WAITON(checkallx)
    ;;
fetchall)       ########################################################################################
    cd ${portsdir}
    if  [ -z "${1}" ] ; then
        list=` ${ls} -l\
             | ${grep} -v '^total '\
             | ${awk} '{print $2 " " $9}'\
             | ${sed} -e 's|^\([0-9]\) |    \1 |'\
                      -e 's|^\([0-9][0-9]\) |   \1 |'\
                      -e 's|^\([0-9][0-9][0-9]\) |  \1 |'\
                      -e 's|^\([0-9][0-9][0-9][0-9]\) | \1 |'\
             | ${sort} -r\
             | ${awk} '{print $2}'\
             | ${grep} -vE '^(CVS|distfiles|pkg|Mk|Templates|Tools)$'\
             | ${tr} '\n' ' '
             `
    else
        list="$@"
    fi
    fetchallx() {
        EXELOCK(ports,dnl
            for j in ${list}; do
                if  [  -d \"${portsdir}/\\\\\\\${j}\" ] ; then
                    cd \"${portsdir}/\\\\\\\${j}\"
                    for i in \\\\\\\`${ls} | ${grep} -vE '^(CVS|pkg)$'\\\\\\\` ; do
                        if  [ -d \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\" ] ; then
                            cd \"${portsdir}/\\\\\\\${j}/\\\\\\\${i}\"
                            (   ERROR(,\"                   ----------------------====================== \\\\\\\${j}/\\\\\\\${i}\")
                                ${make} BATCH=YES fetch 1>&2 || :
                              ( echo ; echo ; TBN ; TBN ; TBN ; TBN )\
                            |   ${make} fetch 1>&2 || :
                            ) &
                            load=\\\\\\\$(( \\\\\\\`AWGLOAD\\\\\\\` + \\\\\\\`PARALL\\\\\\\` * 30 ))
                            ${sleep} \\\\\\\`echo \\\\\\\${load} | ${sed} -e 's/^/0/' -e 's/\\\([0-9][0-9]\\\)$/\\\.\\\1/'\\\\\\\`
                            while [ \\\\\\\`AWGLOAD\\\\\\\` -ge 900 -o \\\\\\\`PARALL\\\\\\\` -ge 33 ]; do
                                ERROR(,\",  10 \")
                                ${sleep} 10
                            done
                        fi
                    done
                fi
            done
            wait
)
    }
    WAITON(fetchallx)
    ;;
*)              ########################################################################################
    ${cat} /dev/fd/4
    exit 64
    ;;
esac
